//+----------------------------------------------------------------------------+
//|                                                             stReceiver.mq4 |
//|                                                       . aka KimIV |
//|                                                        http://www.kimiv.ru |
//|                            |
   
//+----------------------------------------------------------------------------+
#property copyright " http://www.kimiv.ru"
#property link      " http://www.kimiv.ru"

//-------    -----------------------------------------+
extern string _P_Expert = "----------   v.0.7";
extern int    Language      = 1;            // : 0-English, 1-
extern int    NumberAccount = 0;            //   
extern bool   AlienDeals    = True;        //   
extern bool   PrintEnable   = True;         //    
extern bool   SetFullOrder  = False;         //   
extern bool   UseSound      = False;        //   
extern string NameFileSound = "expert.wav"; //   
extern string stFileName    = "E:\12\experts\files\stDeals.csv";
string stff    = "memory.txt";
int        ExtHandle=-1;
extern double IntReading    = 1.7;          //     (0- )

extern string _P_Trade = "----------  ";
extern int    Slippage        = 3;     //  
extern int    NumberOfTry     = 5;     //  
extern int    PauseAfterError = 20;    //     
extern double MinimumMargin   = 2000;  //    
extern double MinSizeLots     = 0.1;   //   
extern double Lots            = 0;     //   
extern double MasterLotPiece  = 1;     //    -
extern int    LotDeviation    = 30;    //      .

//-------    -------------------------------------+
bool   Disabled=false;       //   
double bm;                   //  -
string gsFolderNameMT;       //   4
string msg[16][2];
extern int pricefilter=20;
double gcena;
//-------    ------------------------------------------+
#include <stdlib.mqh>
#import "kernel32.dll"
  bool CopyFileA
       ( string lpExistingFileName,    //   
         string lpNewFileName,         //   
         bool   bFailIfExists );       //  
  int GetModuleFileNameA
      ( int    Module,                 // p 
        string FileName,               //   
        int    Size );                 //  
#import


//+----------------------------------------------------------------------------+
//| expert initialization function                                             |
//+----------------------------------------------------------------------------+
void init() {
  SetSignRunExpert(1);
  //-------------------------------------------
   // if (!GlobalVariableCheck("cnn")) {
   // GlobalVariableSet("cnn", 0);
 // }
  
  //-------------------------------------------
  msg[ 0][1]="For normal functioning of adviser necessary\n"+
             "Allow live trading";
  msg[ 0][1]="    \n"+
             "  ";
  msg[ 1][1]="For normal functioning of adviser necessary\n"+
             "Allow DLL imports";
  msg[ 1][1]="    \n"+
             "    DLL";
  msg[ 2][1]="For normal functioning of adviser necessary\n"+
             "Allow external experts imports";
  msg[ 2][1]="    \n"+
             "    ";
  msg[ 3][0]="Work of second stReceiver is stopped";
  msg[ 3][1]="    stReceiver ";
  msg[ 4][0]="Adviser will is started by next teak";
  msg[ 4][1]="    ";
  msg[ 5][0]="Button is not pressed \"Enable experts for running\"";
  msg[ 5][1]="  \"  \"";
  msg[ 6][0]="IMPOSSIBLE trade on account "+AccountNumber();
  msg[ 6][1]="    "+AccountNumber();
  msg[ 7][0]="IS ABSENT relationship with trade server\n"+
             "Receiving of trade commands is STOPPED";
  msg[ 7][1]="    \n"+
             "   ";
  msg[ 8][0]="Button is not pressed \"Enable experts for running\"\n"+
             "Expert Adviser is STOPPED";
  msg[ 8][1]="  \"  \"\n"+
             " ";
  msg[ 9][0]="Last receiving of commands: ";
  msg[ 9][1]="  : ";
  msg[10][0]="Error of opening of file ";
  msg[10][1]="   ";
  msg[11][0]="Reading of deals ";
  msg[11][1]="  ";
  msg[12][0]="Is not enough free facilities on count ";
  msg[12][1]="     ";
  msg[13][0]="Structure of file is violated ";
  msg[13][1]="   ";
  msg[14][0]="Error of copying of file ";
  msg[14][1]="   ";
  msg[15][0]="Excess percent of possible increase of the size of minimum lot";
  msg[15][1]="      ";

  if (Language<0 || Language>1) Message("Language is invalid");
  if (!IsTradeAllowed()) {
    Message(msg[0][Language]); Disabled=True; return;
  }
  if (!IsDllsAllowed()) {
    Message(msg[1][Language]); Disabled=True; return;
  }
  if (!IsLibrariesAllowed()) {
    Message(msg[2][Language]); Disabled=True; return;
  }
  if (isRunSecond()) {
    Message(msg[3][Language]); Disabled=True; return;
  }
  if (!Disabled) gsFolderNameMT=GetFolderNameMT();
  if (IsExpertEnabled()) Message(msg[4][Language]);
  else Message(msg[5][Language]);
}

//+----------------------------------------------------------------------------+
//| expert deinitialization function                                           |
//+----------------------------------------------------------------------------+
void deinit() {
  SetSignRunExpert(-1);
  Comment("");
}

//+----------------------------------------------------------------------------+
//| expert start function                                                      |
//+----------------------------------------------------------------------------+
void start() {
  if (Disabled) return;
  if (NumberAccount>0 && NumberAccount!=AccountNumber()) {
    Message(msg[6][Language]);
    return;
  }

  if (IntReading<=0) MainBody();
  else {
    while (IsExpertEnabled() && !IsStopped()) {
      if (IsConnected()) {
        MainBody();
       //  gcena=GlobalVariableGet("cnn");
         //Comment
         //Print("last time price",gcena);
        Sleep(1000*IntReading);
      } else Comment(msg[7][Language]);
    }
    Message(msg[8][Language]);
  }
}


//+----------------------------------------------------------------------------+
//|                                     |
//|       -1                             |
//| :                                                                 |
//|   m -                                                       |
//|   e -                                                      |
//+----------------------------------------------------------------------------+
int ArraySearch(int& m[], int e) {
  for (int i=0; i<ArraySize(m); i++) {
    if (m[i]==e) return(i);
  }
  return(-1);
}

//+----------------------------------------------------------------------------+
//|                                   |
//+----------------------------------------------------------------------------+
void CloseOrDelete() {
  bool   fc=False;
  double pp;
  int    err, it;

  for (it=1; it<=NumberOfTry; it++) {
    if (!IsExpertEnabled() || IsStopped()) break;
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    if (OrderType()==OP_BUY) {
      pp=NormalizeDouble(MarketInfo(OrderSymbol(), MODE_BID), MarketInfo(OrderSymbol(), MODE_DIGITS));
      //fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage);
      if (fc) {
        if (UseSound) PlaySound(NameFileSound); break;
      } else {
        err=GetLastError();
        Message("Error("+err+") closing Buy: "+ErrorDescription(err)+", try "+it);
        Sleep(1000*PauseAfterError);
      }
    }
    if (OrderType()==OP_SELL) {
      pp=NormalizeDouble(MarketInfo(OrderSymbol(), MODE_ASK), MarketInfo(OrderSymbol(), MODE_DIGITS));
      //fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage);
      if (fc) {
        if (UseSound) PlaySound(NameFileSound); break;
      } else {
        err=GetLastError();
        Message("Error("+err+") closing Sell: "+ErrorDescription(err)+", try "+it);
        Sleep(1000*PauseAfterError);
      }
    }
    if (OrderType()>OP_SELL) {
      fc=OrderDelete(OrderTicket());
      if (fc) {
        if (UseSound) PlaySound(NameFileSound); break;
      } else {
        err=GetLastError();
        Message("Error("+err+") deleting "+GetNameOP(OrderType())+": "+ErrorDescription(err)+", try "+it);
        Sleep(1000*PauseAfterError);
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|        MagicNumber            |
//| :                                                                 |
//|   mn - MagicNumber                                                         |
//+----------------------------------------------------------------------------+
bool ExistOrder(int mn) {
  
  //return(False);
            for(int i=OrdersTotal()-1;i>=0;i--){
                if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
                        if(OrderMagicNumber()==mn){return(true);}
                }
        }
        for(i=OrdersHistoryTotal()-1;i>=0;i--){
                if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
                        if(OrderMagicNumber()==mn){return(true);}
                }
        }
  //      return(false);
  return(False);
}

//+----------------------------------------------------------------------------+
//|                                       |
//+----------------------------------------------------------------------------+
string ExtractFileName(string FullName) {
  int np=StringFind(FullName, "\\");
  while (np>=0) {
    FullName=StringSubstr(FullName, np+1);
    np=StringFind(FullName, "\\");
  }
  return(FullName);
}

//+----------------------------------------------------------------------------+
//|     4                                            |
//+----------------------------------------------------------------------------+
string GetFolderNameMT() {
  int    i, k;
  string FolderName=
  "                                                                                                                                                                                                                                                               ";
  GetModuleFileNameA(0, FolderName, 255);
  k=StringLen(FolderName);
  for (i=k; i>0; i--) {
    if (StringGetChar(FolderName, i)==92) break;
  }
  FolderName=StringSubstr(FolderName, 0, i+1);
  return(FolderName);
}

//+----------------------------------------------------------------------------+
//|                                      |
//| :                                                                 |
//|   op -                                        |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
	switch (op) {
		case OP_BUY      : return("Buy");
		case OP_SELL     : return("Sell");
		case OP_BUYLIMIT : return("Buy Limit");
		case OP_SELLLIMIT: return("Sell Limit");
		case OP_BUYSTOP  : return("Buy Stop");
		case OP_SELLSTOP : return("Sell Stop");
		default          : return("Unknown Operation");
	}
}

//+----------------------------------------------------------------------------+
//|                                                        |
//| :                                                                 |
//|   sy -                                                               |
//|   lo -   -                                            |
//+----------------------------------------------------------------------------+
double GetSizeLot(string sy, double lo) {
  double dLot, mml=MarketInfo(sy, MODE_MINLOT);
  int    kd;

  if (MasterLotPiece>0) dLot=lo*MasterLotPiece;
  else dLot=lo*AccountBalance()/bm;

  if (mml==0) mml=MinSizeLots;
  if (mml<0.1) kd=2;
  else if (mml>0.1) kd=0;
  else kd=1;
  if (Lots>=mml) dLot=Lots;
  else {
    if (dLot<mml*(1-LotDeviation/100)) dLot=0;
    else {
      dLot=NormalizeDouble(dLot, kd);
      if (dLot<mml) dLot=mml;
    }
  }

  return(dLot);
}

//+----------------------------------------------------------------------------+
//|      .                         |
//+----------------------------------------------------------------------------+
bool isRunSecond() {
 // if (GlobalVariableGet("NumberOfInitReceiver")>1) return(True);
 // else 
  return(False);
}

//+----------------------------------------------------------------------------+
//|                                                        |
//+----------------------------------------------------------------------------+
void MainBody() {
  //    
  int      oti[];       //  ( )
  double oot[];       //  
  int      oty[];       // 
  double   olo[];       // 
  string   osy[];       // 
  double   oop[];       //  
  double   osl[];       // 
  double   otp[];       // 
  string   oco[];       // 
  //   
  string   stF;         //  
  int      h;           //   
  string   pn;          //   
  string   pk;          //   
  int      cd;          //  
  int      io;          //    
  int      i;           //    
  int      ia;          //    
  datetime tl;          //    
  int      sti[];       //      
  string   st;          //  
  int      sc;          //     

  stF=ExtractFileName(stFileName);
  if (CopyFileA(stFileName, gsFolderNameMT+"experts\files\\"+stF, False)) {
    h=FileOpen(stF, FILE_READ|FILE_CSV, ";");
    if (h<0) Message(msg[10][Language]+stF);
    else {
      pn=FileReadString(h);     //   
      cd=FileReadNumber(h);     //  
      bm=FileReadNumber(h);     //  -
      sc=FileReadNumber(h);     //     
      io=FileReadNumber(h);     //    
      ArrayResize(oti, cd);
      ArrayResize(oot, cd);
      ArrayResize(oty, cd);
      ArrayResize(olo, cd);
      ArrayResize(osy, cd);
      ArrayResize(oop, cd);
      ArrayResize(osl, cd);
      ArrayResize(otp, cd);
      ArrayResize(oco, cd);
      if (cd>0) {
        for (i=0; i<cd; i++) {
          oti[i]=-FileReadNumber(h);   //  ( )
          oot[i]=FileReadNumber(h);    //   
          oty[i]=FileReadNumber(h);    // 
          olo[i]=FileReadNumber(h);    // 
          osy[i]=FileReadString(h);    // 
          oop[i]=FileReadNumber(h);    //  
          osl[i]=FileReadNumber(h);    // 
          otp[i]=FileReadNumber(h);    // 
          oco[i]=FileReadString(h);    // 
        }
        Message(msg[11][Language]+cd);
      }
      pk=FileReadString(h);            //   
      FileClose(h);
      tl=TimeLocal();

      if (pn=="=begin=" && pk=="=end=") {
        //    
        for (i=OrdersTotal()-1; i>=0; i--) {
          if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
            ia=ArraySearch(oti, OrderMagicNumber());
            if (ia<0) {
              if (AlienDeals) {
                //if (OrderMagicNumber()<0) CloseOrDelete();
              } else CloseOrDelete();
            } else Modify(oop[ia], osl[ia], otp[ia]);
          }
        }
 ExtHandle=FileOpen(stff,FILE_CSV|FILE_READ,';');
             if   (ExtHandle>1) 
             {
             gcena=StrToDouble(FileReadString(ExtHandle))+10;
             FileClose(ExtHandle); 
             }
        //    
        ArrayResize(sti, OrdersTotal());
        for (i=0; i<OrdersTotal(); i++) {
          if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) sti[i]=OrderMagicNumber();
        }
        for (i=0; i<ArraySize(oti); i++) {
          if (ArraySearch(sti, oti[i])<0) {
            if (AccountFreeMargin()>=MinimumMargin || MinimumMargin==0) {
              if (oty[i]==OP_BUY || oty[i]==OP_SELL) {
                if (io<=0 || sc-oot[i]<io) {
               
             Print("last time open",gcena);
                // gcena=GlobalVariableGet("cnn");
                Alert("oti[",i,"]=",oti[i]);
                  if (SetFullOrder&&oot[i]>gcena&&GetOrder(oti[i])==false) {
                    OpenPosition(osy[i], oty[i], olo[i], osl[i], otp[i], oco[i], oti[i]);
                    ExtHandle=FileOpen(stff,FILE_CSV|FILE_WRITE,';');
                    FileWrite(ExtHandle,oot[i]);
                    FileClose(ExtHandle);
                  //  GlobalVariableSet("cnn", Time);
                  } else {
                    OpenPosition(osy[i], oty[i], olo[i], 0, 0, oco[i], oti[i]);
                 //      GlobalVariableSet("cnn", Time);
                                     ExtHandle=FileOpen(stff,FILE_CSV|FILE_WRITE,';');
                    FileWrite(ExtHandle,oot[i]);
                    FileClose(ExtHandle);
                  }
                }
              } else {
                if (SetFullOrder&&oot[i]>gcena&&GetOrder(oti[i])==false) {
                
                  SetOrder(osy[i], oty[i], olo[i], oop[i], osl[i], otp[i], oco[i], oti[i]);
                                      ExtHandle=FileOpen(stff,FILE_CSV|FILE_WRITE,';');
                    FileWrite(ExtHandle,oot[i]);
                    FileClose(ExtHandle);
                 //    GlobalVariableSet("cnn", Time);
                } else {
                
                  SetOrder(osy[i], oty[i], olo[i], oop[i], 0, 0, oco[i], oti[i]);
                                      ExtHandle=FileOpen(stff,FILE_CSV|FILE_WRITE,';');
                    FileWrite(ExtHandle,oot[i]);
                    FileClose(ExtHandle);
             //        GlobalVariableSet("cnn", Time);
                }
              }
            } else Message(msg[12][Language]+AccountNumber());
          }
        }
      } else Message(msg[13][Language]+stF);
      st=msg[9][Language]+TimeToStr(tl, TIME_DATE|TIME_SECONDS);
      //Comment(st);
      Comment(gcena);
    }
  } else Message(msg[14][Language]+stF);
}

//+----------------------------------------------------------------------------+
//|                                              |
//+----------------------------------------------------------------------------+
void Message(string m) {
  //Comment(m);
  if (StringLen(m)>0 && PrintEnable) Print(m);
}

//+----------------------------------------------------------------------------+
//|                                     |
//+----------------------------------------------------------------------------+
void Modify(double oop, double osl, double otp) {
  bool fc=False;
  int  err, it;

  for (it=1; it<=NumberOfTry; it++) {
    if (!IsExpertEnabled() || IsStopped()) break;
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
      if (OrderStopLoss()!=osl || OrderTakeProfit()!=otp) {
        fc=OrderModify(OrderTicket(), OrderOpenPrice(), osl, otp, 0);
        if (fc) {
          if (UseSound) PlaySound(NameFileSound); break;
        } else {
          err=GetLastError();
          Print("Error("+err+") modifying "+GetNameOP(OrderType())+": "+ErrorDescription(err)+", try "+it);
          Sleep(1000*PauseAfterError);
        }
      }
    } else {
      if (OrderOpenPrice()!=oop || OrderStopLoss()!=osl || OrderTakeProfit()!=otp) {
        fc=OrderModify(OrderTicket(), oop, osl, otp, 0);
        if (fc) {
          if (UseSound) PlaySound(NameFileSound); break;
        } else {
          err=GetLastError();
          Print("Error("+err+") modifying "+GetNameOP(OrderType())+": "+ErrorDescription(err)+", try "+it);
          Print("Ask=", MarketInfo(OrderSymbol(), MODE_ASK),
                "  Bid=", MarketInfo(OrderSymbol(), MODE_BID),
                "  oop=", oop, "  osl=", osl, "  otp=", otp);
          Sleep(1000*PauseAfterError);
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|                                                             |
//| :                                                                 |
//|   sy -                                                               |
//|   op -                                                             |
//|   lo -                                                                 |
//|   sl -                                                                 |
//|   tp -                                                                 |
//|   co -                                                          |
//|   mn -                                                                |
//+----------------------------------------------------------------------------+
void OpenPosition(string sy, int op, double lo, double sl, double tp, string co, int mn) {
  double ll, pp;
  int    err, it, ticket;

  ll=GetSizeLot(sy, lo);
  if (ll>0) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsExpertEnabled() || IsStopped()) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
        Alert("mn=",mn);
      if (op==OP_BUY) pp=MarketInfo(sy, MODE_ASK); else pp=MarketInfo(sy, MODE_BID);
      pp=NormalizeDouble(pp, MarketInfo(sy, MODE_DIGITS));
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, co, mn, 0);
      if (ticket>0) {
        if (UseSound) PlaySound(NameFileSound); break;
      } else {
        err=GetLastError();
        if (err==128 || err==142 || err==143 || err==144) {
          Sleep(1000*PauseAfterError);
          if (ExistOrder(mn)) {
            if (UseSound) PlaySound(NameFileSound); break;
          }
          Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
          continue;
        }
        if (err==146) while (IsTradeContextBusy()) Sleep(1000*PauseAfterError);
        Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
        Print("Ask=", MarketInfo(sy, MODE_ASK),
              "  Bid=", MarketInfo(sy, MODE_BID),
              "  ll=", ll, "  op=", GetNameOP(op),
              "  pp=", pp, "  sl=", sl, "  tp=", tp, "  mn=", mn);
        if (err==2 || err==64 || err==65 || err==4110 || err==4111) break;
        Sleep(1000*PauseAfterError);
      }
    }
  } else Message(msg[15][Language]);
}

//+----------------------------------------------------------------------------+
//|                                                             |
//| :                                                                 |
//|   sy -                                                               |
//|   op -                                                             |
//|   lo -                                                                 |
//|   pp -                                                            |
//|   sl -                                                                 |
//|   tp -                                                                 |
//|   co -                                                          |
//|   mn -                                                                |
//+----------------------------------------------------------------------------+
void SetOrder(string sy, int op, double lo, double pp, double sl, double tp, string co, int mn) {
  double ll;
  int    err, it, ticket;

  ll=GetSizeLot(sy, lo);
  if (ll>0) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsExpertEnabled() || IsStopped()) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      Alert("mn=",mn);
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, co, mn, 0);
      if (ticket>0) {
        if (UseSound) PlaySound(NameFileSound); break;
      } else {
        err=GetLastError();
        if (err==128 || err==142 || err==143 || err==144) {
          Sleep(1000*PauseAfterError);
          if (ExistOrder(mn)) {
            if (UseSound) PlaySound(NameFileSound); break;
          }
          Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
          continue;
        }
        if (err==146) while (IsTradeContextBusy()) Sleep(1000*PauseAfterError);
        Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
        Print("Ask=", MarketInfo(sy, MODE_ASK),
              "  Bid=", MarketInfo(sy, MODE_BID),
              "  ll=", ll, "  op=", GetNameOP(op),
              "  pp=", pp, "  sl=", sl, "  tp=", tp, "  mn=", mn);
        if (err==2 || err==64 || err==65 || err==4110 || err==4111) break;
        Sleep(1000*PauseAfterError);
      }
    }
  } else Message(msg[15][Language]);
}

//+----------------------------------------------------------------------------+
//|    .                                       |
//+----------------------------------------------------------------------------+
void SetSignRunExpert(int k) {
  int lk;
  if (!GlobalVariableCheck("NumberOfInitReceiver")) {
    GlobalVariableSet("NumberOfInitReceiver", 0);
  }
  lk=GlobalVariableGet("NumberOfInitReceiver")+k;
  if (lk>0) GlobalVariableSet("NumberOfInitReceiver", lk);
  else GlobalVariableDel("NumberOfInitReceiver");
}
//+----------------------------------------------------------------------------+
bool GetOrder(int mn){int i ;
        for(i=OrdersTotal()-1;i>=0;i--){
                if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
                        if(OrderMagicNumber()==mn){return(true);}
                }
        }
        for(i=OrdersHistoryTotal()-1;i>=0;i--){
                if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)){
                        if(OrderMagicNumber()==mn){return(true);}
                }
        }
        return(false);  
}